package ws.standalone.cou.test;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class GraphicalUserInterface implements ActionListener{
	// Initialize all swing objects.
    private JFrame 			frame 				= new JFrame("Fire Protection System 1.0");
    private JPanel 			panel1 	    		= new JPanel();
    private JPanel 			panel2 	    		= new JPanel();
    private JScrollPane		mssgPanel			= new JScrollPane();
    private JTextArea     	mssgArea    		= new JTextArea(20,20);
    
    //Valors provinents de la mota
    private JLabel 			title1Label			= new JLabel("Data sensors ->");
    private JLabel 			vccFromMote_Label 	= new JLabel("V.C.C");
    private JTextField     	vccFromMote_Text    = new JTextField("0.00");    
    private JLabel 			tempFromMote_Label 	= new JLabel(" TEMP");
    private JTextField     	tempFromMote_Text   = new JTextField("0.00");
    
    //Labels per mostrar les dos alarmes
    // -Verd tot OK
    // -Vermell alarma!!
    private JLabel 			alarmVoltage_Label	= new JLabel("Voltage alarm");
    private JLabel 			alarmTemp_Label 	= new JLabel("Temperature alarm");
    
    //Valors a actualitzar, pel control de temperatura, i timers amb el que la mota pren valosr i envia dels sensors
    private JLabel 			timerReadSet_Label 	= new JLabel("Read Timer (ms)");
    private JTextField     	timerReadSet_Text   = new JTextField("500");
    private JLabel 			timerSendSet_Label 	= new JLabel("Send Timer (ms)");
    private JTextField     	timerSendSet_Text   = new JTextField("1000");
    //private JLabel 		vccSetLimit_Label 	= new JLabel("V.C.C limit");
    //private JTextField    vccSetLimit_Text   	= new JTextField("2.5");
    private JLabel 			tempSetLimit_Label 	= new JLabel("Temp limit");
    private JTextField     	tempSetLimit_Text   = new JTextField("100");
    
    private JButton			updateTimerRead		= new JButton("Update Timer Read");
    private JButton			updateTimerSend		= new JButton("Update Timer Send");    
    private JButton			updateLimitTemp		= new JButton("Update Limit Temp");
    private JButton			ConfirmAlarmTemp	= new JButton("Confirm Alarm Temp");
    
    /** Constructor for the GUI */
    public GraphicalUserInterface(){
    	frame.setMinimumSize(new Dimension(540, 270));
    	frame.setResizable(false);
    	
    	title1Label.setForeground(Color.BLACK);
    	vccFromMote_Label.setForeground(Color.gray);
    	vccFromMote_Text.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
    	vccFromMote_Text.setForeground(Color.BLACK);
    	vccFromMote_Text.setEditable(false);
    	tempFromMote_Label.setForeground(Color.gray);
    	tempFromMote_Text.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
    	tempFromMote_Text.setForeground(Color.BLACK);
    	tempFromMote_Text.setEditable(false);    	
    	alarmVoltage_Label.setOpaque(true);
    	alarmVoltage_Label.setBackground(Color.decode("#009900"));
    	alarmTemp_Label.setOpaque(true);
    	alarmTemp_Label.setBackground(Color.decode("#009900"));    	
    	panel1.setLayout(new FlowLayout(FlowLayout.LEFT));
    	panel1.setBackground(Color.lightGray);
    	panel1.add(title1Label);
    	panel1.add(vccFromMote_Label);
    	panel1.add(vccFromMote_Text);
    	panel1.add(tempFromMote_Label);
    	panel1.add(tempFromMote_Text);
    	panel1.add(alarmVoltage_Label);
    	panel1.add(alarmTemp_Label);
    	panel1.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
    	frame.add(panel1,BorderLayout.NORTH);
    	
    	timerReadSet_Text.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
    	timerReadSet_Text.setForeground(Color.BLACK);
    	timerSendSet_Text.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
    	timerSendSet_Text.setForeground(Color.BLACK);
    	tempSetLimit_Text.setBorder(BorderFactory.createLineBorder(Color.gray, 1));
    	tempSetLimit_Text.setForeground(Color.BLACK);    	
    	updateTimerRead.addActionListener(this);
    	updateTimerSend.addActionListener(this);
    	updateLimitTemp.addActionListener(this);
    	ConfirmAlarmTemp.addActionListener(this);
    	panel2.setLayout(new BoxLayout(panel2,BoxLayout.Y_AXIS));
    	panel2.add(timerReadSet_Label);
    	panel2.add(timerReadSet_Text);
    	panel2.add(updateTimerRead);
    	panel2.add(timerSendSet_Label);
    	panel2.add(timerSendSet_Text);
    	panel2.add(updateTimerSend);
    	panel2.add(tempSetLimit_Label);
    	panel2.add(tempSetLimit_Text);
    	panel2.add(updateLimitTemp);
    	panel2.add(ConfirmAlarmTemp);
    	frame.add(panel2,BorderLayout.EAST);
    	
    	mssgPanel.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    	mssgPanel.setBorder(BorderFactory.createEmptyBorder(2, 0, 0, 0));
    	mssgPanel.setAutoscrolls(true);
    	mssgPanel.getViewport().add(mssgArea, null);    	    	
    	mssgArea.setFont(new java.awt.Font("Monospaced", Font.PLAIN, 12));
    	frame.add(mssgPanel,BorderLayout.CENTER);
        
    	frame.addWindowListener(new ListenEvents());
    }
	
    /*
     * Mètode d'escolta d'events perquè quan es tanqui la finestra tanqui l'aplicació*/
    public class ListenEvents extends WindowAdapter{
        public void windowClosing(WindowEvent e){
            System.exit(0);         
        }
    }
	
    /*
     * Impprimeix per pantalla els valors del voltatge i de temeperatura*/
    public void DataShow(String vcc, String temp){
    	vccFromMote_Text.setText(vcc);
    	tempFromMote_Text.setText(temp);
    }
    
    /*
     * Imprimeix en el textàrea el valor de text*/
    public void TextShow(String text){
    	mssgArea.append(text+"\n");
    }
    
    /*
     * Retorna el valor del quadre de text timerReadSet_Text*/
    public String retornaReadTimer(){
    	return timerReadSet_Text.getText();
    }
    
    /*
     * Retorna el valor del quadre de text timerSendSet_Text*/    
    public String retornaSendTimer(){
    	return timerSendSet_Text.getText();
    }    
    
    /*
     * Formateja el valor de temperatura a l'escala amb la que treballa la mota*/
    public int retornaTemplimit(){
    	double temp = Double.parseDouble(tempSetLimit_Text.getText());
    	temp = (temp*0.01)+0.5;
    	temp = ((temp*1024)/2.56);
    	return (int) temp;
    }
    
    /*
     * Retorna el valor del quadre de text tempSetLimit_Text*/ 
    public String retornaStringTemplimit(){
    	return tempSetLimit_Text.getText();
    }    
    
    /*
     * Canvia el color del label alarmVoltage_Label*/
    public void alarmVcc(Color c){
    	alarmVoltage_Label.setBackground(c);
    }

    /*
     * Canvia el color del label alarmTemp_Label*/
    public void alarmTemp(Color c){
    	alarmTemp_Label.setBackground(c);
    }
    
    /*
     * Dimensiona i posiciona la pantalla de l'aplicació en la pantalla*/
    public void launchFrame(){
        // Display Frame
        Dimension dim = Toolkit.getDefaultToolkit().getScreenSize();
        
	    // Determine the new location of the window
        int w = frame.getSize().width;
        int h = frame.getSize().height;
        int x = (dim.width-w)/2;
        int y = (dim.height-h)/2;
		  
        //Move the window
        frame.setLocation(x, y);        
        frame.setVisible(true);
    }
    
    /*
     * Segons el botó que pitjem es farà el que segueix*/
	public void actionPerformed(ActionEvent e) {
		if (e.getSource()==updateTimerRead) {
			FireProtectionSystemJava.actualitzaTimerRead(retornaReadTimer());
		}		
		if (e.getSource()==updateTimerSend) {
			FireProtectionSystemJava.actualitzaTimerSend(retornaSendTimer());
		}		
		if (e.getSource()==updateLimitTemp) {
			FireProtectionSystemJava.actualitzaLimitTemp(retornaTemplimit());
		}
		if (e.getSource()==ConfirmAlarmTemp) {
			FireProtectionSystemJava.confirmAlarmTemp();
		}		
	}
}